From: Ondrej Jirman <megous@megous.com>
Date: Tue, 9 Jun 2020 21:11:09 -0500
Subject: [PATCH 142/194] arm64: dts: a64: pinephone: Add ANX chip for all PP
 variants 1.0-1.2

Signed-off-by: Ondrej Jirman <megous@megous.com>
[Samuel: Factored out common properties]
Signed-off-by: Samuel Holland <samuel@sholland.org>
---
 .../dts/allwinner/sun50i-a64-pinephone-1.0.dts     | 10 +++++++
 .../dts/allwinner/sun50i-a64-pinephone-1.1.dts     | 10 +++++++
 .../dts/allwinner/sun50i-a64-pinephone-1.2.dts     |  9 ++++++
 .../boot/dts/allwinner/sun50i-a64-pinephone.dtsi   | 34 +++++++++++++++++++++-
 4 files changed, 62 insertions(+), 1 deletion(-)

diff --git a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.0.dts b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.0.dts
index 0384eed..a52a2d5 100644
--- a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.0.dts
+++ b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.0.dts
@@ -10,6 +10,11 @@ / {
 	compatible = "pine64,pinephone-1.0", "pine64,pinephone", "allwinner,sun50i-a64";
 };
 
+&anx7688 {
+	reset-gpios = <&r_pio 0 9 GPIO_ACTIVE_HIGH>; /* PL9 */
+	avdd33-supply = <&reg_dldo1>;
+};
+
 &axp803 {
 	x-powers,drive-vbus-en;
 };
@@ -18,6 +23,11 @@ &codec_analog {
 	allwinner,internal-bias-resistor;
 };
 
+/*
+ * The N_VBUSEN pin is disconnected, but we need to inform the PMIC about
+ * the VBUS status anyway. To avoid the pin from floating and to inform
+ * the PMIC, about VBUS status, we couple reg_drivevbus with reg_vbus.
+ */
 &reg_drivevbus {
 	vin-supply = <&reg_vcc5v0>;
 	status = "okay";
diff --git a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.1.dts b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.1.dts
index d26fe5d..e21cfc7 100644
--- a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.1.dts
+++ b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.1.dts
@@ -10,6 +10,11 @@ / {
 	compatible = "pine64,pinephone-1.1", "pine64,pinephone", "allwinner,sun50i-a64";
 };
 
+&anx7688 {
+	reset-gpios = <&r_pio 0 9 GPIO_ACTIVE_HIGH>; /* PL9 */
+	avdd33-supply = <&reg_dldo1>;
+};
+
 &axp803 {
 	x-powers,drive-vbus-en;
 };
@@ -37,6 +42,11 @@ &codec_analog {
 	allwinner,internal-bias-resistor;
 };
 
+/*
+ * The N_VBUSEN pin is disconnected, but we need to inform the PMIC about
+ * the VBUS status anyway. To avoid the pin from floating and to inform
+ * the PMIC, about VBUS status, we couple reg_drivevbus with reg_vbus.
+ */
 &reg_drivevbus {
 	vin-supply = <&reg_vcc5v0>;
 	status = "okay";
diff --git a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.2.dts b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.2.dts
index 636dd39..9a271b6 100644
--- a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.2.dts
+++ b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone-1.2.dts
@@ -15,6 +15,11 @@ wifi_pwrseq: wifi-pwrseq {
 	};
 };
 
+&anx7688 {
+	reset-gpios = <&pio 3 6 GPIO_ACTIVE_HIGH>; /* PD6 */
+	avdd33-supply = <&reg_dcdc1>;
+};
+
 &axp803 {
 	x-powers,sense-vbus-en;
 };
@@ -62,6 +67,10 @@ &reg_anx_vdd1v0 {
 };
 
 &reg_usb0_vbus {
+	/*
+	 * ANX7688 will enable/disable USB-5V <-> DCIN switch by itself
+	 * via VBUS_CTRL pin, so no GPIO is needed here.
+	 */
 	vin-supply = <&reg_vcc5v0>;
 };
 
diff --git a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone.dtsi b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone.dtsi
index db0c42f..945445b 100644
--- a/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone.dtsi
+++ b/arch/arm64/boot/dts/allwinner/sun50i-a64-pinephone.dtsi
@@ -263,6 +263,31 @@ &ehci1 {
 &i2c0 {
 	status = "okay";
 
+	anx7688: hdmi-bridge@28 {
+		compatible = "analogix,anx7688";
+		reg = <0x28>;
+
+		interrupt-parent = <&r_pio>;
+		interrupts = <0 11 IRQ_TYPE_EDGE_FALLING>; /* PL11 */
+
+		enable-gpios = <&pio 3 10 GPIO_ACTIVE_LOW>; /* PD10 */
+		cabledet-gpios = <&r_pio 0 8 GPIO_ACTIVE_HIGH>; /* PL8 */
+
+		avdd10-supply = <&reg_anx_vdd1v0>;
+		dvdd10-supply = <&reg_anx_vdd1v0>;
+		avdd18-supply = <&reg_ldo_io1>;
+		dvdd18-supply = <&reg_ldo_io1>;
+		vconn-supply = <&reg_vconn5v0>;
+		hdmi_vt-supply = <&reg_dldo1>;
+		vbus-supply = <&reg_usb0_vbus>;
+
+		port {
+			typec0_drd_sw: endpoint {
+				remote-endpoint = <&usb0_drd_sw>;
+			};
+		};
+	};
+
 	touchscreen@5d {
 		compatible = "goodix,gt917s";
 		reg = <0x5d>;
@@ -680,7 +705,7 @@ &uart3 {
 };
 
 &usb_otg {
-	dr_mode = "peripheral";
+	dr_mode = "otg";
 	status = "okay";
 };
 
@@ -689,5 +714,12 @@ &usb_power_supply {
 };
 
 &usbphy {
+	usb-role-switch;
 	status = "okay";
+
+	port {
+		usb0_drd_sw: endpoint {
+			remote-endpoint = <&typec0_drd_sw>;
+		};
+	};
 };
